package APMS::Model::ProcedureMapper;

=item APMS::Model::ProcedureMapper

Map a 4GL procedure name to a Perl-APMS class name.

  my $class = APMS::Model::ProcedureMapper->mapper( <4gl procedure> );

APMS stores procedures in the database to call from buttons and links.
These procedures are files in the APMS source, and so must be mapped to
Perl class names instead. The class names will simply have the "run"
method called on them.

Ideally the database should be converted to store these Perl class
names instead, but this provides that functionality if required.

=cut

my $mappings = {
	'b-prglnk2' => '',
	'compliance/b-building-systems.w' => '',
	'compliance/b-inspectors.w' => '',
	'compliance/v-building-system.w' => '',
	'compliance/v-inspector.w' => '',
	'forecast/b-prop-fc-param.w' => '',
	'forecast/b-prop-fc-type.w' => '',
	'forecast/b-scenario-assumptions.w' => '',
	'forecast/v-amtrust-market-rents.w' => '',
	'forecast/v-amtrust-rent-report.w' => '',
	'forecast/v-amtrust-to-budget.w' => '',
	'forecast/v-run-amtrust-rental.w' => '',
	'forecast/v-scenario-assumption.w' => '',
	'rplctn/b-repcol.w' => '',
	'rplctn/b-replog.w' => '',
	'rplctn/b-reprul.w' => '',
	'rplctn/b-reptrg.w' => '',
	'sec/b-menuitem.w'                 => 'APMS::Control::Security::MenuBrowser',
	'sec/b-user.w' => '',
	'sec/b-usrgrp.w' => '',
	'sec/v-user.w' => '',
	'sec/v-usgmem.w' => '',
	'sec/v-usgmnu.w' => '',
	'sec/v-usrgrp-members.w' => '',
	'vwr/drl/b-accounts-call.w' => '',
	'vwr/drl/b-actacx.w' => '',
	'vwr/drl/b-actbal.w' => '',
	'vwr/drl/b-actdoc.w' => '',
	'vwr/drl/b-actgrp.w' => '',
	'vwr/drl/b-actold.w' => '',
	'vwr/drl/b-actsum.w' => '',
	'vwr/drl/b-apprvr.w' => '',
	'vwr/drl/b-areastatus.w' => '',
	'vwr/drl/b-aretyp.w' => '',
	'vwr/drl/b-autext.w' => '',
	'vwr/drl/b-bank-exception.w' => '',
	'vwr/drl/b-batch0.w' => '',
	'vwr/drl/b-bldg-system-type.w' => '',
	'vwr/drl/b-bnkact.w' => 'APMS::Control::Drill::BankAccount',
	'vwr/drl/b-cfchgt.w' => '',
	'vwr/drl/b-cfltyp.w' => '',
	'vwr/drl/b-cheque.w' => '',
	'vwr/drl/b-choact.w' => 'APMS::Control::Drill::ChartAccount',
	'vwr/drl/b-chqfix.w' => '',
	'vwr/drl/b-client.w' => '',
	'vwr/drl/b-clsgrp.w' => '',
	'vwr/drl/b-compny.w'               => 'APMS::Control::Drill::Company',
	'vwr/drl/b-conlst.w' => '',
	'vwr/drl/b-contrt.w' => '',
	'vwr/drl/b-crdtor.w' => '',
	'vwr/drl/b-cshflw.w' => '',
	'vwr/drl/b-ctctyp.w' => '',
	'vwr/drl/b-debt-class.w' => '',
	'vwr/drl/b-dirctr.w' => '',
	'vwr/drl/b-docact.w' => '',
	'vwr/drl/b-docbch.w' => '',
	'vwr/drl/b-doctyp.w' => '',
	'vwr/drl/b-e-contact-type.w' => '',
	'vwr/drl/b-entity-contact.w' => '',
	'vwr/drl/b-entity-list-member.w' => '',
	'vwr/drl/b-entity-list.w' => '',
	'vwr/drl/b-estass.w' => '',
	'vwr/drl/b-fnclyr.w' => '',
	'vwr/drl/b-frqtyp.w' => '',
	'vwr/drl/b-grdlse.w' => '',
	'vwr/drl/b-gtrtls.w' => '',
	'vwr/drl/b-image-type.w' => '',
	'vwr/drl/b-image.w' => '',
	'vwr/drl/b-invtrm.w' => '',
	'vwr/drl/b-ivoice.w'               => 'APMS::Control::Drill::Invoice',
	'vwr/drl/b-lookup-code.w' => '',
	'vwr/drl/b-lsesta.w' => '',
	'vwr/drl/b-lsetyp.w' => '',
	'vwr/drl/b-month2.w' => '',
	'vwr/drl/b-month.w' => '',
	'vwr/drl/b-newbch.w' => '',
	'vwr/drl/b-ocaofc.w' => '',
	'vwr/drl/b-office.w' => '',
	'vwr/drl/b-ordprj.w' => '',
	'vwr/drl/b-ostofc.w' => 'APMS::Control::Maint::OfficeSettings',
	'vwr/drl/b-paysty.w' => '',
	'vwr/drl/b-person-detail-type.w' => '',
	'vwr/drl/b-person.w' => '',
	'vwr/drl/b-pexcat.w' => '',
	'vwr/drl/b-phntyp.w' => '',
	'vwr/drl/b-postyp.w' => '',
	'vwr/drl/b-prjbdg.w' => '',
	'vwr/drl/b-prjtyp.w' => '',
	'vwr/drl/b-projct.w' => '',
	'vwr/drl/b-project-tree.w' => '',
	'vwr/drl/b-property-outgoing.w' => '',
	'vwr/drl/b-property-view.w' => '',
	'vwr/drl/b-proper.w' => '',
	'vwr/drl/b-ptipro.w' => '',
	'vwr/drl/b-quevue.w' => '',
	'vwr/drl/b-rchgln.w' => '',
	'vwr/drl/b-rchsts.w' => '',
	'vwr/drl/b-rchtyp.w' => '',
	'vwr/drl/b-region.w' => '',
	'vwr/drl/b-rntass.w' => '',
	'vwr/drl/b-rntchr.w' => '',
	'vwr/drl/b-rntrvw.w' => '',
	'vwr/drl/b-rntspc.w' => '',
	'vwr/drl/b-rsphst.w' => '',
	'vwr/drl/b-rvusta.w' => '',
	'vwr/drl/b-rvutyp.w' => '',
	'vwr/drl/b-scnpar.w' => '',
	'vwr/drl/b-scnrio.w' => '',
	'vwr/drl/b-scnsts.w'        => '',
	'vwr/drl/b-shrhld.w'        => '',
	'vwr/drl/b-srvtyp.w'        => '',
	'vwr/drl/b-stfrnt.w'        => '',
	'vwr/drl/b-subtls.w'        => '',
	'vwr/drl/b-supply-meters.w' => '',
	'vwr/drl/b-tenant-call.w'   => 'APMS::Control::Window::TenantCall',
	'vwr/drl/b-tenant.w'        => 'APMS::Control::Drill::Tenant',
	'vwr/drl/b-tntlse.w'        => '',
	'vwr/drl/b-unpresented-cheques.w' => '',
	'vwr/drl/b-usgrts.w'        => '',
	'vwr/drl/b-valtyp.w' => '',
	'vwr/drl/b-valutn.w' => '',
	'vwr/drl/b-varflw.w' => '',
	'vwr/drl/b-variance-class.w' => '',
	'vwr/drl/b-varitn.w' => '',
	'vwr/drl/b-vartyp.w' => '',
	'vwr/drl/b-vcntsp.w' => '',
	'vwr/drl/b-vouchr.w' => '',
	'vwr/drl/v-ross.w' => '',
	'vwr/drl/v-totals.w' => '',
	'vwr/mnt/v-actgrp.w' => '',
	'vwr/mnt/v-actual-recoveries.w' => '',
	'vwr/mnt/v-approved-vouchers.w' => '',
	'vwr/mnt/v-apprvr.w' => '',
	'vwr/mnt/v-autcls.w' => '',
	'vwr/mnt/v-bchtol.w' => '',
	'vwr/mnt/v-bldg-system-type.w' => '',
	'vwr/mnt/v-bldinc.w' => '',
	'vwr/mnt/v-bnkact.w' => 'APMS::Control::Maint::BankAccount',
	'vwr/mnt/v-budget.w' => '',
	'vwr/mnt/v-budrpt.w' => '',
	'vwr/mnt/v-building-wof.w' => '',
	'vwr/mnt/v-cheque-view.w' => '',
	'vwr/mnt/v-cheque.w' => '',
	'vwr/mnt/v-cheque-whites.w' => '',
	'vwr/mnt/v-choact.w' => '',
	'vwr/mnt/v-chqrep.w' => '',
	'vwr/mnt/v-chqrun.w' => '',
	'vwr/mnt/v-client.w' => '',
	'vwr/mnt/v-cmplst.w' => '',
	'vwr/mnt/v-coalst.w' => '',
	'vwr/mnt/v-compny.w' => '',
	'vwr/mnt/v-conlst.w' => '',
	'vwr/mnt/v-construction.w' => '',
	'vwr/mnt/v-contrt.w' => '',
	'vwr/mnt/v-crdtor.w' => '',
	'vwr/mnt/v-cshflw.w' => '',
	'vwr/mnt/v-ctlst.w' => '',
	'vwr/mnt/v-ctrlst.w' => '',
	'vwr/mnt/v-ctypsn.w' => '',
	'vwr/mnt/v-dbstat.w' => '',
	'vwr/mnt/v-dbtrpt.w' => '',
	'vwr/mnt/v-depsit.w' => '',
	'vwr/mnt/v-depsyd.w' => '',
	'vwr/mnt/v-dirctr.w' => '',
	'vwr/mnt/v-elcinv.w' => '',
	'vwr/mnt/v-email.w' => '',
	'vwr/mnt/v-entity-contact.w' => '',
	'vwr/mnt/v-entsel.w' => '',
	'vwr/mnt/v-expcrd.w' => '',
	'vwr/mnt/v-expct2.w' => '',
	'vwr/mnt/v-expctc.w' => '',
	'vwr/mnt/v-expctr.w' => '',
	'vwr/mnt/v-expense-variance.w' => '',
	'vwr/mnt/v-explnk.w' => '',
	'vwr/mnt/v-export-balances.w' => '',
	'vwr/mnt/v-fidchg.w' => '',
	'vwr/mnt/v-frecst.w' => '',
	'vwr/mnt/v-frqtyp.w' => '',
	'vwr/mnt/v-garntr.w' => '',
	'vwr/mnt/v-genrpt.w' => '',
	'vwr/mnt/v-grdlse.w' => '',
	'vwr/mnt/v-grplst.w' => '',
	'vwr/mnt/v-grpown.w' => '',
	'vwr/mnt/v-image.w' => '',
	'vwr/mnt/v-impanz.w' => '',
	'vwr/mnt/v-impctc.w' => '',
	'vwr/mnt/v-implnk.w' => '',
	'vwr/mnt/v-intchk.w' => '',
	'vwr/mnt/v-invapp.w' => '',
	'vwr/mnt/v-invoice-statement.w' => '',
	'vwr/mnt/v-ivoice.w' => 'APMS::Control::Maint::Invoice',
	'vwr/mnt/v-kckprt.w' => '',
	'vwr/mnt/v-kcktru.w' => '',
	'vwr/mnt/v-lsxpry.w' => '',
	'vwr/mnt/v-maturity.w' => '',
	'vwr/mnt/v-mgcapx.w' => '',
	'vwr/mnt/v-mglexp.w' => '',
	'vwr/mnt/v-mgnlse.w' => '',
	'vwr/mnt/v-mgrvrn.w' => '',
	'vwr/mnt/v-mgrvwo.w' => '',
	'vwr/mnt/v-mgvcnt.w' => '',
	'vwr/mnt/v-month-end-og-accrual.w' => '',
	'vwr/mnt/v-monthly-gst.w' => '',
	'vwr/mnt/v-nbctol.w' => '',
	'vwr/mnt/v-office.w' => '',
	'vwr/mnt/v-og-budget-watchlist.w' => '',
	'vwr/mnt/v-og-differences.w' => '',
	'vwr/mnt/v-ogperc.w' => '',
	'vwr/mnt/v-order-mgmt.w' => '',
	'vwr/mnt/v-order.w' => '',
	'vwr/mnt/v-pcntct.w' => '',
	'vwr/mnt/v-person.w' => '',
	'vwr/mnt/v-pink.w' => '',
	'vwr/mnt/v-pmtsum.w' => '',
	'vwr/mnt/v-portfolio-expiry.w' => '',
	'vwr/mnt/v-portfolio-yield.w' => '',
	'vwr/mnt/v-prdcom.w' => '',
	'vwr/mnt/v-prjbdg.w' => '',
	'vwr/mnt/v-prjcfl.w' => '',
	'vwr/mnt/v-prjcsh.w' => '',
	'vwr/mnt/v-prjord.w' => '',
	'vwr/mnt/v-prjtrk.w' => '',
	'vwr/mnt/v-prjvar.w' => '',
	'vwr/mnt/v-projct.w' => '',
	'vwr/mnt/v-proper.w' => '',
	'vwr/mnt/v-prospd.w' => '',
	'vwr/mnt/v-protit.w' => '',
	'vwr/mnt/v-proval.w' => '',
	'vwr/mnt/v-prplst.w' => '',
	'vwr/mnt/v-rchgln.w' => '',
	'vwr/mnt/v-reprnt.w' => '',
	'vwr/mnt/v-rntadv.w' => '',
	'vwr/mnt/v-rntchg-date.w' => '',
	'vwr/mnt/v-rntchg.w' => '',
	'vwr/mnt/v-rntchr.w' => '',
	'vwr/mnt/v-rntinv.w' => '',
	'vwr/mnt/v-rntrvw.w' => '',
	'vwr/mnt/v-rntrvw.w' => '',
	'vwr/mnt/v-rntspc.w' => '',
	'vwr/mnt/v-rntsum.w' => '',
	'vwr/mnt/v-rrvrpt.w' => '',
	'vwr/mnt/v-runprg.w' => '',
	'vwr/mnt/v-schdul.w' => '',
	'vwr/mnt/v-scnass.w' => '',
	'vwr/mnt/v-scnbud.w' => '',
	'vwr/mnt/v-scnrio.w' => '',
	'vwr/mnt/v-scntol.w' => '',
	'vwr/mnt/v-selprt.w' => '',
	'vwr/mnt/v-selscn.w' => '',
	'vwr/mnt/v-shrhld.w' => '',
	'vwr/mnt/v-statmt.w' => '',
	'vwr/mnt/v-subrec.w' => '',
	'vwr/mnt/v-tbgrpt.w' => '',
	'vwr/mnt/v-tenant-charges.w' => '',
	'vwr/mnt/v-tenant-details.w' => '',
	'vwr/mnt/v-tenant-outgoing-budgets.w' => '',
	'vwr/mnt/v-tenant.w' => 'APMS::Control::Maint::Tenant',
	'vwr/mnt/v-tntbal.w' => '',
	'vwr/mnt/v-tntls2.w' => '',
	'vwr/mnt/v-tntlse.w' => '',
	'vwr/mnt/v-tntlst.w' => '',
	'vwr/mnt/v-tr-c.w' => '',
	'vwr/mnt/v-treprt.w' => '',
	'vwr/mnt/v-tr-j.w' => '',
	'vwr/mnt/v-tr-l.w' => '',
	'vwr/mnt/v-tr-p.w' => '',
	'vwr/mnt/v-tr-t.w' => '',
	'vwr/mnt/v-unpchq.w' => '',
	'vwr/mnt/v-valuation.w' => '',
	'vwr/mnt/v-varflw.w' => '',
	'vwr/mnt/v-varitn.w' => '',
	'vwr/mnt/v-vchap2.w' => '',
	'vwr/mnt/v-vchenq.w' => '',
	'vwr/mnt/v-vouchr.w' => '',
	'vwr/mnt/v-wall.w' => '',
	'vwr/mnt/v-xperod.w' => '',
	'vwr/mnt/v-yrend.w' => '',
	'vwr/run/v-amtrust-rs-multipliers.w' => '',
	'vwr/run/v-amtrust-tenant-fcast.w' => '',
	'vwr/run/v-bldg-area-reconciliation.w' => '',
	'vwr/run/v-building-act.w' => '',
	'vwr/run/v-carpark-report.w' => '',
	'vwr/run/v-creditor-list.w' => '',
	'vwr/run/v-curr-inc-bud-exp.w' => '',
	'vwr/run/v-expired-leases.w' => '',
	'vwr/run/v-import-transactions.w' => '',
	'vwr/run/v-outgoings-amtrust.w' => '',
	'vwr/run/v-property-picture.w' => '',
	'vwr/run/v-property-tb.w' => '',
	'vwr/run/v-property-verification.w' => '',
	'vwr/run/v-sydney-wall.w' => '',
	'vwr/run/v-tenant-calls.w' => '',
	'vwr/run/v-tenant-rentals.w' => '',
	'vwr/run/v-tenants-unwashed.w' => '',
	'vwr/run/v-to-do.w' => '',
	'vwr/run/v-tog-budget.w' => '',
	'vwr/run/v-warden-summary.w' => '',
	'vwr/sel/b-selapp.w' => '',
	'vwr/sel/b-selclient.w' => '',
	'vwr/sel/b-selcmp.w' => '',
	'vwr/sel/b-selcoa.w' => '',
	'vwr/sel/b-selcrd.w' => '',
	'vwr/sel/b-selfyr.w' => '',
	'vwr/sel/b-selmtr.w' => '',
	'vwr/sel/b-selnbc.w' => '',
	'vwr/sel/b-selprj.w' => '',
	'vwr/sel/b-selpro.w' => '',
	'vwr/sel/b-selpsn.w' => '',
	'vwr/sel/b-selscn.w' => '',
	'vwr/sel/b-seltnt.w' => '',
	'workflow/b-activity-status.w' => '',
	'workflow/b-asset-status.w' => '',
	'workflow/b-asset-type.w' => '',
	'workflow/b-flow-rule-type.w' => '',
	'workflow/b-flow-rule.w' => '',
	'workflow/b-flow-step-type.w' => '',
	'workflow/b-flow-step.w' => '',
	'workflow/b-flow-task-type.w' => '',
	'workflow/b-flow-task.w' => '',
	'workflow/b-todo-task.w' => '',
	'workflow/v-flow-rule.w' => '',
	'workflow/v-flow-step-type.w' => '',
	'workflow/v-flow-step.w' => '',
	'workflow/v-flow-task-type.w' => '',
	'workflow/v-flow-task.w' => '',
};

sub mapper {
	my ( $proto, $key ) = @_;

	if ( exists $mappings->{$key} ) {
		return $mappings->{$key};
	}
	else {
		return undef;
	}
}

1;

=head2 Licence

Copyright (C) 2007 by Chris Eade

This library is free software; you can redistribute it and/or modify it under
the terms of the GNU Library General Public License as published by the Free
Software Foundation; either version 2.1 of the License, or (at your option) any
later version.

=cut

